Index: ChangeLog
===================================================================
RCS file: /cvs/ecos/ecos/packages/redboot/current/ChangeLog,v
retrieving revision 1.263
diff -u -r1.263 ChangeLog
--- ChangeLog	6 Feb 2009 15:39:29 -0000	1.263
+++ ChangeLog	17 Feb 2009 16:07:22 -0000
@@ -1,3 +1,8 @@
+2009-02-17  Rene Schipp von Branitz Nielsen <rbn@vitesse.com>
+
+	* src/flash.c: Fix compilation warnings when redundant FIS
+	is selected.
+
 2009-02-06  John Dallaway  <john@dallaway.org.uk>
 
 	* cdl/redboot.cdl: Fix documentation reference.
Index: src/flash.c
===================================================================
RCS file: /cvs/ecos/ecos/packages/redboot/current/src/flash.c,v
retrieving revision 1.86
diff -u -r1.86 flash.c
--- src/flash.c	29 Jan 2009 17:50:04 -0000	1.86
+++ src/flash.c	17 Feb 2009 16:07:23 -0000
@@ -169,7 +169,7 @@
 void *fis_work_block;
 cyg_flashaddr_t fis_addr;
 #ifdef CYGOPT_REDBOOT_REDUNDANT_FIS
-void *redundant_fis_addr;
+cyg_flashaddr_t redundant_fis_addr;
 #endif
 int fisdir_size;  // Size of FIS directory.
 #endif
@@ -286,8 +286,8 @@
 #endif
 
    struct fis_image_desc* img=NULL;
-   cyg_flashaddr_t err_addr=NULL;
-   cyg_flashaddr_t tmp_fis_addr=NULL;
+   cyg_flashaddr_t err_addr;
+   cyg_flashaddr_t tmp_fis_addr;
    int stat;
 
    /*exchange old and new valid fis tables*/
@@ -310,14 +310,15 @@
 #endif
 
    if ((stat = cyg_flash_erase(fis_addr, fisdir_size, &err_addr)) != 0) {
-       diag_printf("Error erasing FIS directory at %p: %s\n", err_addr, cyg_flash_errmsg(stat));
+       diag_printf("Error erasing FIS directory at %p: %s\n",
+                   (void*)err_addr, cyg_flash_errmsg(stat));
        return 1;
    }
    //now magic is 0xffffffff
    fis_endian_fixup(fis_work_block);
    if ((stat = cyg_flash_program(fis_addr, fis_work_block, flash_block_size, &err_addr)) != 0) {
        diag_printf("Error writing FIS directory at %p: %s\n",
-                   err_addr, cyg_flash_errmsg(stat));
+                   (void*)err_addr, cyg_flash_errmsg(stat));
        return 1;
    }
    fis_endian_fixup(fis_work_block);
@@ -360,13 +361,13 @@
    //but IN_PROGRESS is also good enough I think
    if (error!=0)
    {
-      void* swap_fis_addr=fis_addr;
+      cyg_flashaddr_t swap_fis_addr=fis_addr;
       fis_addr=redundant_fis_addr;
       redundant_fis_addr=swap_fis_addr;
    }
    else //success
    {
-      void* tmp_fis_addr=(void *)((CYG_ADDRESS)fis_addr+CYG_REDBOOT_RFIS_VALID_MAGIC_LENGTH);
+      cyg_flashaddr_t tmp_fis_addr=((CYG_ADDRESS)fis_addr+CYG_REDBOOT_RFIS_VALID_MAGIC_LENGTH);
 
       img->u.valid_info.valid_flag[0]=CYG_REDBOOT_RFIS_VALID;
       img->u.valid_info.valid_flag[1]=CYG_REDBOOT_RFIS_VALID;
@@ -374,7 +375,7 @@
       if ((stat = cyg_flash_program(tmp_fis_addr, img->u.valid_info.valid_flag,
                                     sizeof(img->u.valid_info.valid_flag), &err_addr)) != 0) {
           diag_printf("Error writing FIS directory at %p: %s\n", 
-                      err_addr, cyg_flash_errmsg(stat));
+                      (void*)err_addr, cyg_flash_errmsg(stat));
       }
    }
 #ifdef CYGHWR_IO_FLASH_BLOCK_LOCKING
@@ -463,7 +464,7 @@
 fis_erase_redundant_directory(void)
 {
     int stat;
-    void *err_addr;
+    cyg_flashaddr_t err_addr;
 
 #ifdef CYGSEM_REDBOOT_FLASH_LOCK_SPECIAL
     // Ensure [quietly] that the directory is unlocked before trying
@@ -474,7 +475,7 @@
     if ((stat = cyg_flash_erase(redundant_fis_addr, fisdir_size,
                                 &err_addr)) != 0) {
          diag_printf("Error erasing FIS directory at %p: %s\n",
-                     err_addr, cyg_flash_errmsg(stat));
+                     (void*)err_addr, cyg_flash_errmsg(stat));
     }
 #ifdef CYGSEM_REDBOOT_FLASH_LOCK_SPECIAL
     // Ensure [quietly] that the directory is locked after the update
@@ -670,7 +671,7 @@
         }
         if ((stat = cyg_flash_erase(erase_start, erase_size,&err_addr)) != 0) {
           diag_printf("   initialization failed %p: %s\n",
-                 err_addr, cyg_flash_errmsg(stat));
+                      (void*)err_addr, cyg_flash_errmsg(stat));
         }
         erase_start += (erase_size + flash_block_size);
         if (fis_addr > cfg_base) {
@@ -680,7 +681,7 @@
         }
         if ((stat = cyg_flash_erase(erase_start, erase_size,&err_addr)) != 0) {
           diag_printf("   initialization failed %p: %s\n",
-                 err_addr, cyg_flash_errmsg(stat));
+                      (void*)err_addr, cyg_flash_errmsg(stat));
         }
         erase_start += (erase_size + flash_block_size);
 #else  // !CYGSEM_REDBOOT_FLASH_CONFIG        
@@ -1923,11 +1924,11 @@
 #ifdef CYGOPT_REDBOOT_REDUNDANT_FIS
 
         if (CYGNUM_REDBOOT_FIS_REDUNDANT_DIRECTORY_BLOCK < 0) {
-            redundant_fis_addr = (void *)((CYG_ADDRESS)flash_end + 1 +
-                                          (CYGNUM_REDBOOT_FIS_REDUNDANT_DIRECTORY_BLOCK*flash_block_size));
+            redundant_fis_addr = ((CYG_ADDRESS)flash_end + 1 +
+                                  (CYGNUM_REDBOOT_FIS_REDUNDANT_DIRECTORY_BLOCK*flash_block_size));
         } else {
-            redundant_fis_addr = (void *)((CYG_ADDRESS)flash_start +
-                                (CYGNUM_REDBOOT_FIS_REDUNDANT_DIRECTORY_BLOCK*flash_block_size));
+            redundant_fis_addr = ((CYG_ADDRESS)flash_start +
+                                  (CYGNUM_REDBOOT_FIS_REDUNDANT_DIRECTORY_BLOCK*flash_block_size));
         }
 
         if (((CYG_ADDRESS)redundant_fis_addr + fisdir_size - 1) > (CYG_ADDRESS)flash_end) {
@@ -1955,7 +1956,7 @@
         if (fis_get_valid_buf(&img0, &img1, &fis_update_was_interrupted)==1)
         {
            // Valid, so swap primary and secondary
-           void * tmp;
+           cyg_flashaddr_t tmp;
            tmp = fis_addr;
            fis_addr = redundant_fis_addr;
            redundant_fis_addr = tmp;
